/*  Definitions for doxygen
	(Never included by c++ compilers)
*/

/** \defgroup WidgetControls Widgets
  */

/** \defgroup aspects::Classes Aspect Classes
  */

/** \defgroup GlobalStuff Global typedefs and functions
  * Global functions and typedefs or things in general not belonging to any
  * particular class.
  */

/** \defgroup WidgetLayout Layout of widgets in windows
  * \htmlinclude layout.html
  */

/** \defgroup SubclassDialog Dialog Subclassing Functions
  */

/**
  * \defgroup eventsSignatures  Event Signatures
  *
  * See MessageMapControl.h
  *
*/


/** \defgroup EventHandlersaspects::Clickable Event Handlers for aspects::Clickable
  * \EventHandlerGenericInfo
  */

/** \defgroup EventHandlersaspects::DblClickable Event Handlers for aspects::DblClickable
  * \EventHandlerGenericInfo
  */

/** \defgroup EventHandlersaspects::Keyboard Event Handlers for aspects::Keyboard
  * \EventHandlerGenericInfo
  */

/** \defgroup EventHandlersaspects::Mouse Event Handlers for aspects::Mouse
  * \EventHandlerGenericInfo
  */

/** \defgroup EventHandlersaspects::Painting Event Handlers for aspects::Painting
  * \EventHandlerGenericInfo
  */

/** \defgroup EventHandlersaspects::Selection Event Handlers for aspects::Selection
  * \EventHandlerGenericInfo
  */

/** \defgroup EventHandlersaspects::Sizable Event Handlers for aspects::Sizable
  * \EventHandlerGenericInfo
  */

/** \defgroup EventHandlersaspects::Enabled Event Handlers for aspects::Enabled
  * \EventHandlerGenericInfo
  */

/** \defgroup EventHandlersaspects::EraseBackground Event Handlers for aspects::EraseBackground
  * \EventHandlerGenericInfo
  */

/** \defgroup EventHandlersaspects::Activate Event Handlers for aspects::Activate
  * \EventHandlerGenericInfo
  */

/** \defgroup EventHandlersaspects::BackgroundColor Event Handlers for aspects::BackgroundColor
  * \EventHandlerGenericInfo
  */

/** \defgroup EventHandlersaspects::AspectFocus Event Handlers for aspects::Focus
  * \EventHandlerGenericInfo
  */

/** \defgroup EventHandlersaspects::Scrollable Event Handlers for aspects::Scrollable
  * \EventHandlerGenericInfo
  */

/** \defgroup EventHandlersaspects::Text Event Handlers for aspects::Text
  * \EventHandlerGenericInfo
  */

/** \defgroup EventHandlersaspects::Update Event Handlers for aspects::Update
  * \EventHandlerGenericInfo
  */

/** \defgroup EventHandlersaspects::Visible Event Handlers for aspects::Visible
  * \EventHandlerGenericInfo
  */

/** \defgroup EventHandlersaspects::RightClickable Event Handlers for aspects::RightClickable
  * \EventHandlerGenericInfo
  */

/** \defgroup EventHandlersTable Event Handlers for Table
  * \EventHandlerGenericInfo
  */

/** \defgroup EventHandlersMenu Event Handlers for Menu
  * \EventHandlerGenericInfo
  */

/** \defgroup EventHandlersToolBar Event Handlers for ToolBar
  * \EventHandlerGenericInfo
  */

/** \defgroup EventHandlersTree Event Handlers for Tree
  * \EventHandlerGenericInfo
  */


/** \page dwt Documentation for DWT
  * \htmlinclude guide.html
  */

/**
  * \page license SmartWin++ license
  * \htmlinclude license.html
*/

/**
  * \page msvc71  MS Visual C++ 7.1
  * \htmlinclude msvc71.html
*/

/**
  * \page devcpp  DEV C++
  * \htmlinclude devcpp.html
*/

/**
  * \page msvctoolkit  MSVC 2003 toolkit
  * \htmlinclude msvcToolkit.html
*/

/**
  * \page eclipse  Eclipse C++ Development Environment
  * \htmlinclude eclipse.html
*/

/**
  * \page linuxwine  Using Winelib to run on Linux
  * \htmlinclude linuxwine.html
*/

/**
  * \page samplecode1  Hello World (small)
   *
   * This is a program to show the basics of SmartWin++
   *
   * \include main.cpp
   *
   * This program compiles into an executable of 155 KB without any extra DLLs needed.
   * Here is a screen shot of two instances running:
   *
   * \image html hello.jpg
   *
   * The two message boxes either say "Hello !" or "Hello World !" depending on the
   * Global checkbox.  The layout logic puts the button either to the right or below
   * the checkbox depending on the window shape.
   *
   * Notice the way events are handled in SmartWin++: you specify a member function
   * that executes when the event happens.
   *
   * Notice also that the button and the checkbox's size are set once.  But their
   * runtime position depends on how the window is resized by the user. The resource
   * editor was not used in this sample. although SmartWin++ can use the MSVC
   * resource editor if you want to.
   *
   * <a href="samplecode2.html"> Here is a larger example </a>
   * There are 40 other source code samples.
*/

/**
  * \page samplecode2  Hello World (big)
   * This is a program to show most of the features being used together.
   *
   * \include hello.cpp
   *
   * This program compiles into an executable of 268 KB without any extra DLLs needed.
   *
   * \image html helloSmartWin.jpg
*/
